use crate::{
    bussy::PubSub,
    utils::{error::Error, structs::Subscription},
};

use nostr::{Event, RelayMessage};
use std::sync::Arc;

pub trait Noose: Send + Sync {
    async fn start(&mut self, pubsub: Arc<PubSub>) -> Result<(), Error>;

    async fn migration_up(&self);

    async fn write_event(&self, event: Box<Event>) -> Result<RelayMessage, Error>;

    async fn delete_events(&self, event_ids: Box<Event>) -> Result<RelayMessage, Error>;

    async fn find_event(&self, subscription: Subscription) -> Result<Vec<String>, Error>;
}
